/* config.h
   This is a replacement for the file ../config.h which is produced by
   the GNU configure script on Unix systems.  Most of these symbols
   cannot be turned on as they will turn on X-specific code.  Some
   should work, however. */

/* Do you have OpenGL?
   Set this to 0 if you don't plan to use OpenGL, and fltk will be smaller */
#define HAVE_GL 1
/* Turn this on if your GL card has overlay hardware (nyi): */
#define HAVE_GL_OVERLAY 1

/* this symbol not used by win32: */
#define HAVE_XCOLORMAP 0

/* X specific, leave off: */
#define HAVE_XDBE 0

/* X specific, leave off: */
#define HAVE_OVERLAY 0

/* Byte order of your machine: (not used by win32 code) */
#define WORDS_BIGENDIAN 0

/* Types that are 32 bits and 16 bits long.  Used by fl_draw_image only: */
#define U_SHORT unsigned short /* hack to outwit ./configure */
#define U16 U_SHORT
#define U32 unsigned

/* Where is <dirent.h> (used only by fl_file_chooser and scandir): */
#define HAVE_DIRENT_H 1
#define HAVE_SYS_NDIR_H 0
#define HAVE_SYS_DIR_H 0
#define HAVE_NDIR_H 0
